macroScript zeroOut
	category:"Comet Cartoons"
	toolTip:"zeroOut: Inserts a helper object above the selected object(s) in the hierarchy to make values zero."
	Icon:#("CometCartoons",19)
(

--
--  zeroOut - Michael B. Comet - comet@comet-cartoons.com - http://www.comet-cartoons.com/
--		Copyright 2002 Michael B. Comet  All Rights Reserved
--
--	Version 1.00 - 3/03/2002
--


    objs = getCurrentSelection();
	oc = objs.count;

    undo "ZEROOut" on (
	
	    setWaitCursor();

		for i in 1 to oc do 
		    (
			pt = Point pos:[0,0,0] isSelected:on centermarker:on axistripod:off cross:off Box:off constantscreensize:off drawontop:off size:20;
				-- Insert into hierarchy
			pt.parent = objs[i].parent;
				-- Now snap it to same values
			coordsys world 
				(
				pt.scale = objs[i].scale;
				pt.rotation = objs[i].rotation;
				pt.position = objs[i].position;
				pt.wirecolor = (color 80 10 0);
				pt.name = (objs[i].name+"ZERO");
				)
				-- reparent object
			objs[i].parent = pt;
		    )

		-- finally reselect original objects
		select objs;
		
		setArrowCursor();
		) -- end undo
	
)

