-- showMap - Michael B. Comet - comet@comet-cartoons.com - http://www.comet-cartoons.com/
--
--
-- Turns on diffuse maps in viewports for all standard materials and the first level of
-- multi sub-object materials that have them
--
-- Michael B. Comet  - 6/18/99 - comet@volition-inc.com
--		Initial Rev, coded for Volition Incorporated!  Yay Freespace and Summoner!
--						www.volition-inc.com
--
-- Michael B. Comet - 2/25/01 - comet@comet-cartoons.com, prepped for public release, dang this
--							is some nasty code, but at least it works... :)


---- show_diffuse_map(mat, onoff)
----    Returns the filename and turns the map to the state of onoff, otherwise returns undefined
fn show_diffuse_map mat onoff =
(
    if (mat == undefined) then
	    return undefined

try
(
		-- look for texturemap info...
	mname = mat.diffusemap.filename
	showTextureMap mat mat.diffusemap onoff
	return mname;
)
catch
(

)
    return undefined;
)


------ is_multi(mat) 
------    Returns true is the material given is a multi-subobj, false otherwise
fn is_multi mat =
(
    if (mat == undefined) then
	    return false;
	
try
(
    numsubs = mat.numsubs		-- how many does it say
	for i = 1 to numsubs do		-- loop on names, since this sometimes gives bogus numbers
	(
		mname = mat[i].name
	)
	return true;
)
catch
(
)
	return false;
)

------ show_maps(onoff)
------     Main Start Loop...
fn show_maps onoff =
(
	numsubs = 0;
	
		-- how many materials are there in the scene?
	num_matls = sceneMaterials.count
		
	format "% materials in scene\n" num_matls


	progressStart("Showing Maps for Materials...")

		-- For each material, see if it's a multisub or not...
	for m = 1 to num_matls do
	(
		mat = sceneMaterials[m];
		if (is_multi(mat)) then 
		(
			format "Material % has % submaterials\n" mat.name mat.numsubs
			
				-- only would need to collapse if > 1 subs...
			for i = 1 to mat.numsubs do 
			(
				format "Turning show diffuse map to % for % \n" onoff mat[i].name
				show_diffuse_map mat[i] onoff;
			)
		) else (
			-- maybe it's a standard
			format "Turning show diffuse map to % for % \n" onoff mat.name
			show_diffuse_map mat onoff;
		)
		
		progressUpdate( 100.0 * m / num_matls );
	)
	
	progressEnd();
)

-- The main Options Rollout
rollout ro_options "Action"
(
	button b_doon "Turn Diffuse Maps ON" width:150
	button b_dooff "Turn Diffuse Maps OFF" width:150
	
		-- Time to do the collapsing!
    on b_doon pressed do
	(
		format "-- Show Maps started at: %\n" localtime

	    show_maps( on );
		max views redraw		-- redraw viewports to update stuff

		format "-- Show Maps ended at: %\n" localtime
	)

    on b_dooff pressed do
	(
		format "-- Show Maps started at: %\n" localtime

	    show_maps( off );
		max views redraw		-- redraw viewports to update stuff

		format "-- Show Maps ended at: %\n" localtime
	)

)

-- The About Rollout
rollout ro_about "About"
(
	label abt_lbl1 "Version 1.00";
	label abt_lbl5 "by Michael B. Comet";
	label abt_lbl6 "comet@comet-cartoons.com";
	label abt_lbl7 "http://www.comet-cartoons.com/";
	label abt_lbl8 "June 18, 1999";
	label abt_lbl9 "Coded for Volition, Inc.";
	label abt_lbl10 "Hello Timmy!";
)

-- Make the Floater!
ro_floater = (newRolloutFloater "Comet - Show Map" 200 145)
addRollout ro_options  ro_floater
addRollout ro_about  ro_floater rolledUp:true


